apiVersion: v1
kind: Service
metadata:
  labels:
    app: thanos-query
    app.kubernetes.io/component: query-layer
    app.kubernetes.io/instance: thanos-query
    app.kubernetes.io/name: thanos-query
#    app.kubernetes.io/version: v0.24.0
  annotations:
    prometheus.io/path: /metrics
    prometheus.io/port: "10902"
    prometheus.io/scrape: "true"
  name: thanos-query
spec:
  ports:
    - port: 9090
      protocol: TCP
      targetPort: http
      name: http
    - port: 10901
      protocol: TCP
      targetPort: grpc
      name: grpc
  selector:
    app: thanos-query
    app.kubernetes.io/component: query-layer
    app.kubernetes.io/instance: thanos-query
    app.kubernetes.io/name: thanos-query
  sessionAffinity: None
---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: thanos-query
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: thanos-query
  labels:
    app: thanos-query
    app.kubernetes.io/component: query-layer
    app.kubernetes.io/instance: thanos-query
    app.kubernetes.io/name: thanos-query
spec:
  replicas: 3
  selector:
    matchLabels:
      app: thanos-query
      app.kubernetes.io/name: thanos-query
  template:
    metadata:
      labels:
        app: thanos-query
        app.kubernetes.io/name: thanos-query
        app.kubernetes.io/component: query-layer
        app.kubernetes.io/instance: thanos-query
    spec:
      affinity:
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - podAffinityTerm:
                labelSelector:
                  matchExpressions:
                    - key: app.kubernetes.io/name
                      operator: In
                      values:
                        - thanos-query
                namespaces:
                  - thanos
                topologyKey: kubernetes.io/hostname
              weight: 100
      serviceAccountName: thanos-query
      containers:
        - name: thanos-query
          image: thanos
          args:
            - query
            - --grpc-address=0.0.0.0:10901
            - --http-address=0.0.0.0:10902
            - --log.level=warn
            - --query.replica-label=replica
            - --store.sd-files=/etc/thanos/store-sd.yaml
            - --store.response-timeout=15s
          ports:
            - name: http
              containerPort: 10902
            - name: grpc
              containerPort: 10901
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /-/healthy
              port: http
              scheme: HTTP
            periodSeconds: 60
            successThreshold: 1
            timeoutSeconds: 1
          readinessProbe:
            failureThreshold: 3
            httpGet:
              path: /-/ready
              port: http
              scheme: HTTP
            periodSeconds: 60
            successThreshold: 1
            timeoutSeconds: 1
          resources:
            requests:
              cpu: 50m
              memory: 500Mi
            limits:
              memory: 4000Mi
          volumeMounts:
            - name: config
              mountPath: /etc/thanos
      securityContext:
        fsGroup: 65534
        runAsUser: 65534
      volumes:
        - name: config
          configMap:
            name: thanos-query
